## crawl 0.12.1

=== source/Makefile ===
# vim:set ts=8 sw=4 noexpandtab:
#
# Dungeon Crawl Stone Soup
# GNU Makefile
#
# largely written by Steven Noonan <steven@uplinklabs.net>
#    (if something breaks, blame him.)
#

# Typical targets:
#    make
#    make debug
#    make debug-lite    # Like "make debug", but without all the spew.
#    make install
#    make debug install
#    -- note, unlike most programs, you need to specify build type when
#       installing even if you just built it.
# Typical parameters:
#    TILES         -- set to anything to enable tiles build
#
#    CROSSHOST     -- target system, eg, i386-pc-msdosdjgpp or i586-mingw32msvc
#
#    prefix        -- installation base.  Specify eg. /usr/local on Unix systems.
#    DESTDIR       -- installation staging area (the dir you intend to pack)
#    DATADIR       -- place to hold immutable files.  Can be either relative to
#                     "prefix" or absolute.
#    SAVEDIR       -- place to hold writeable data (saves, database, morgue
#                     dumps).  Can be relative to "prefix", absolute or placed
#                     in the user's home dir (~).  Remember to protect the ~
#                     from your shell!
#                     Warning, as of 0.8, directories shared between
#                     multiple system users are no longer supported.
#    SHAREDDIR     -- place to hold writeable data common to multiple
#                     versions of Crawl (scores, the logfile, ghosts).  Will
#                     be placed inside the SAVEDIR if not specified.
#       Layout examples:
#         prefix=~/crawl DATADIR=data/ SAVEDIR=saves/
#                  -- everything under ~/crawl
#         prefix=/usr/local
#                  -- system-wide installation
#
#    V             -- set to anything to enable verbose build
#
#    USE_ICC       -- set to use Intel's compiler
#    LTO           -- set for better optimization but slower compilation,
#                     requires gcc4.6+
#    NOASSERTS     -- set to disable assertion checks (ignored in debug mode)
#    NOWIZARD      -- set to disable wizard mode.  Use if you have untrusted
#                     remote players without DGL.
#
#    PROPORTIONAL_FONT -- set to a .ttf file you want to use for a proportional
#                         font; if not set, a copy of Bitstream Vera Sans
#                         shipped with Crawl will be used
#    MONOSPACED_FONT   -- monospaced font; Bitstream Vera Mono Sans
#    COPY_FONTS    -- force installing fonts
#
#    WEBTILES      -- set to anything to compile for Webtiles
#    WEBDIR        -- place to hold the Webtiles client data. Can be either
#                     relative to prefix or absolute.
#
#    ANDROID       -- perform an Android build (see docs/develop/android.txt)
#    TOUCH_UI      -- enable UI behaviour more compatible with touch-screens
#
#
# Requirements:
#    For tile builds, you need pkg-config.
#    You also need libpng, sdl, sdl-image and libfreetype -- if you got your
#    source from git, you can 'git submodule update' to fetch them; you can also
#    ask for a package with convenience libraries instead -- we'll try to provide
#    them somewhere in the near future.

GAME = crawl

# Disable GNU Make implicit rules and variables. Leaving them enabled will slow
# down MinGW and Cygwin builds by a very VERY noticeable degree. Besides, we have
# _explicit_ rules defined for everything. So we don't need them.
MAKEFLAGS += -rR # This only works for recursive makes, i.e. contribs ...
.SUFFIXES:       # ... so zap the suffix list to neutralize most predifined rules, too

.PHONY: all test install clean clean-contrib clean-rltiles clean-android \
        distclean debug debug-lite profile package-source source \
        build-windows package-windows rest docs greet api android

include Makefile.obj

#
# Compiler Flags
#
# The compiler flag variables are separated into their individual
# purposes, making it easier to deal with the various tools involved
# in a compile.
#
# These are also divided into global vs. local flags. So for instance,
# CFOPTIMIZE affects Crawl, Lua, and SQLite, while CFOPTIMIZE_L only
# affects Crawl.
#
# The variables are as follows:
# CFOPTIMIZE(_L) - Optimization flags
# CFWARN(_L) - Warning flags
# CFOTHERS(_L) - Anything else
#


ifdef USE_ICC

# If you have a Core 2 processor, this _really_ makes things fly:
#CFOPTIMIZE := -O2 -parallel -xT

# Optionally enable the 'ipo' feature, to facilitate inlining
# across object file bounds.
#CFOPTIMIZE_L := -ipo

# Some very good optimization flags.
CFOPTIMIZE := -O2 -parallel

else

CFOPTIMIZE := -O2

endif # USE_ICC

CFOTHERS := -pipe $(EXTERNAL_FLAGS)
CFWARN := -Wall -Wformat-security
CFWARN_L := -Wundef

DEFINES := $(EXTERNAL_DEFINES)

ifdef ANDROID
LDFLAGS := $(EXTERNAL_LDFLAGS) $(LDFLAGS)
else
LDFLAGS := $(EXTERNAL_LDFLAGS)
endif

#
# The GCC and GXX variables are set later.
#
AR = ar
RANLIB = ranlib
CC = $(GCC)
CXX = $(GXX)
RM = rm -f
COPY = cp
COPY_R = cp -r
STRIP = strip -s
WINDRES = windres
CHMOD = chmod 2>/dev/null
CHOWN = chown 2>/dev/null
PNGCRUSH = $(COPY)
PNGCRUSH_LABEL = COPY
ADVPNG = advpng -z -4
PKGCONFIG = pkg-config
DOXYGEN = doxygen
DOXYGEN_SIMPLE_CONF = crawl_simple.doxy
DOXYGEN_ALL_CONF = crawl_all.doxy
DOXYGEN_HTML_GEN = html/

export AR
export RANLIB
export RM
export CC
export CXX
export CFLAGS
export MAKEFLAGS
export CONFIGURE_FLAGS
export uname_S

#
# Platform Detection
#
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')
uname_O := $(shell sh -c 'uname -o 2>/dev/null || echo not')
uname_R := $(shell sh -c 'uname -r 2>/dev/null || echo not')
uname_P := $(shell sh -c 'uname -p 2>/dev/null || echo not')
uname_V := $(shell sh -c 'uname -v 2>/dev/null || echo not')

HOST := $(shell sh -c 'cc -dumpmachine || echo unknown')
ARCH := $(HOST)

ifdef CROSSHOST
	ARCH := $(CROSSHOST)
	ifneq (,$($shell which $(ARCH)-pkg-config 2>/dev/null))
	  PKGCONFIG = $(ARCH)-pkg-config
	else
	  ifneq (,$(wildcard /usr/$(ARCH)/lib/pkgconfig))
	    PKGCONFIG = PKG_CONFIG_LIBDIR=/usr/$(ARCH)/lib/pkgconfig pkg-config
	  else
	    NO_PKGCONFIG = YesPlease
	    BUILD_LUA = yes
	    BUILD_SQLITE = yes
	    BUILD_ZLIB = YesPlease
	  endif
	endif
	NO_AUTO_OPT = YesPlease
	CONFIGURE_FLAGS += --host=$(CROSSHOST)

	# If needed, override uname_S so we get the appropriate
	# things compiled.
	ifneq (,$(findstring mingw,$(CROSSHOST)))
		uname_S=MINGW32
	endif

endif
ifneq (,$(findstring MINGW,$(uname_S)))
	GAME = crawl.exe
	bin_prefix = .
	WIN32 = Yes
	NO_RDYNAMIC = YesPlease
	NO_NCURSES = YesPlease
	NEED_LIBW32C = YesPlease
	BUILD_PCRE = YesPlease
	BUILD_ZLIB = YesPlease
	DEFINES_L += -DWINMM_PLAY_SOUNDS
	EXTRA_LIBS += -lwinmm
	ifdef TILES
		EXTRA_LIBS += -lmingw32 -lgdi32 -lwinmm contrib/install/$(ARCH)/lib/libSDLmain.a -mwindows
		BUILD_FREETYPE = YesPlease
		BUILD_SDL = YesPlease
		BUILD_SDLIMAGE = YesPlease
		BUILD_LIBPNG = YesPlease
	endif
	ifeq ($(shell gcc -v -static-libstdc++ 2>&1 | grep 'unrecognized option'),)
		EXTRA_LIBS += -static-libgcc -static-libstdc++
	endif
	COPY_FONTS = yes
endif
ifeq ($(uname_S),Darwin)
	STRIP := strip -x
	NEED_APPKIT = YesPlease
	LIBNCURSES_IS_UNICODE = Yes
	NO_PKGCONFIG = Yes
	BUILD_SQLITE = YesPlease
	BUILD_ZLIB = YesPlease
	ifdef TILES
		EXTRA_LIBS += -framework AppKit -framework AudioUnit -framework Carbon -framework IOKit -framework OpenGL contrib/install/$(ARCH)/lib/libSDLmain.a
		BUILD_FREETYPE = YesPlease
		BUILD_SDL = YesPlease
		BUILD_SDLIMAGE = YesPlease
		BUILD_LIBPNG = YesPlease
	endif
	COPY_FONTS = yes
endif
ifdef USE_LUAJIT
	BUILD_LUA := YesPlease
endif
ifdef USE_ICC
	NO_RDYNAMIC := YesPlease
endif
ifneq (,$(findstring CYGWIN,$(uname_S)))
	GAME = crawl.exe
	NO_RDYNAMIC = YesPlease
	BUILD_PCRE = YesPlease
endif

ifdef BUILD_ALL
	BUILD_FREETYPE = YesPlease
	BUILD_PCRE = YesPlease
	BUILD_SDL = YesPlease
	BUILD_SDLIMAGE = YesPlease
	BUILD_SQLITE = YesPlease
	BUILD_LUA = YesPlease
	BUILD_LIBPNG = YesPlease
	BUILD_ZLIB = YesPlease
endif

# Should be the first rule, but must come after $(GAME) is set.
all: greet check-fonts $(GAME) docs webserver

LIBPCRE := contrib/install/$(ARCH)/lib/libpcre.a
LIBSDL := contrib/install/$(ARCH)/lib/libSDL.a
LIBPNG := contrib/install/$(ARCH)/lib/libpng.a
LIBSDLIMAGE := contrib/install/$(ARCH)/lib/libSDL_image.a
LIBFREETYPE := contrib/install/$(ARCH)/lib/libfreetype.a
LIBSQLITE := contrib/install/$(ARCH)/lib/libsqlite3.a
ifdef USE_LUAJIT
LIBLUA := contrib/install/$(ARCH)/lib/libluajit.a
else
LIBLUA := contrib/install/$(ARCH)/lib/liblua.a
endif
LIBZ := contrib/install/$(ARCH)/lib/libz.a

ifndef CROSSHOST
	SQLITE_INCLUDE_DIR := /usr/include
else
	# This is totally wrong, works only with some old-style setups, and
	# on some architectures of Debian/new FHS multiarch -- excluding, for
	# example, i386.  Fortunately, i386 is rarely cross-compiled to.
	# There's no support for /usr/local/ too, without thorough handholding.
	# It's still an improvement over Crawl 0.8 which had no cross-compiling
	# to non-win32 at all.
	#
	# Needs to be replaced by compile checks.  Guessing the paths is fragile,
	# while the compiler knows them already.
	SQLITE_INCLUDE_DIR := /usr/$(ARCH)/include
endif
SQLITE_LIB := -lsqlite3

#
# Set up the TILES variant
#
ifdef TILES
TILES_ANY = YesPlease
OBJECTS += $(TILES_OBJECTS) $(GLTILES_OBJECTS)
  ifdef WEBTILES
    OBJECTS += $(error Web and local tiles are exclusive)
  endif
endif

ifdef WEBTILES
TILES_ANY = YesPlease
OBJECTS += $(TILES_OBJECTS) $(WEBTILES_OBJECTS)
endif

#
# Check for an Apple-released compiler.
#
ifndef NO_APPLE_GCC
ifeq ($(uname_S),Darwin)
ifneq ($(shell gcc -v 2>&1 | grep Apple),)
APPLE_GCC = YesPlease
endif
endif
endif


ifdef WIN32
EXTRA_OBJECTS += icon.o
else
ifndef ANDROID
EXTRA_LIBS += -pthread
endif
endif

ifndef TILES
ifdef NEED_LIBW32C
OBJECTS += libw32c.o
else
OBJECTS += libunix.o
endif
endif

# To get stack trace symbols.
# Note that MinGW doesn't support -rdynamic.
ifndef NO_RDYNAMIC
LDFLAGS += -rdynamic
endif

ifdef USE_MERGE_BASE
MERGE_BASE := $(shell git merge-base HEAD $(USE_MERGE_BASE))
endif

ifdef USE_DGAMELAUNCH
# Permissions to set on the game executable.
MCHMOD := 755

# Permissions to set on the save directory.
MCHMOD_SAVEDIR := 775
MCHMOD_LOGS := 664

# The user:group to install the game as.
INSTALL_UGRP := games:games
endif

chroot_prefix :=
prefix        :=

ifeq ($(patsubst %/local,%,$(patsubst %/,%,$(prefix))),/usr)
FHS := yes
endif

ifeq (,$(bin_prefix))
ifneq ($(patsubst %/,%,$(prefix)),/usr)
bin_prefix    := bin
else
bin_prefix    := games
endif
endif

# If you're installing Crawl for multiple users, you *must* set this to a
# valid path before building Crawl. This is not necessary if you are building
# Crawl for a single user.
# If you're installing to /usr, /usr/local or /opt, we have sane defaults.

# SAVEDIR := saves/
# DATADIR := data/
ifneq (,$(FHS))
DATADIR       := share/crawl
SAVEDIR       := ~/.crawl
endif

ifneq ($(patsubst /opt%,%,$(prefix)),$(prefix))
DATADIR := data
SAVEDIR := ~/.crawl
endif


INCLUDES_L += -Icontrib/install/$(ARCH)/include
LIBS += -Lcontrib/install/$(ARCH)/lib

INCLUDES_L += -Iutil -I.

ifdef APPLE_GCC

MARCH := $(uname_M)


ifndef NO_AUTO_SDK

# The SDK locations were moved in 10.8; this snippet tries to find them
# there first, then reverts to the original location.
ifeq ($(shell test -e /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer || echo NOPE),)
DEVELOPER_PATH := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer
else
DEVELOPER_PATH := /Developer
endif

# Find the oldest SDK available, in attempt to make this build as
# backward-compatible as we possibly can.
SDK_VER := $(shell ls $(DEVELOPER_PATH)/SDKs | sort -n | head -1 | perl -pe 's/^MacOSX//g;s/.sdk$$//g')

ifeq ($(SDK_VER),10.4u)
SDK_VER := 10.4
endif

ifndef SDK_VER
$(error You do not seem to have any Mac OS X SDKs installed! This build is doomed to fail)
endif

endif

ifndef SDK_VER

=== debian/changelog ===
crawl (2:0.12.1-1) unstable; urgency=low

  * New upstream bugfix release
  * Autodetect LTO, to support backports.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 05 May 2013 12:20:44 +0200

crawl (2:0.12.0-1) unstable; urgency=low

  * New upstream release.
  * Revert -Os, benchmarks show it greatly reduces speed even on cache
    starved machines, and Crawl is too CPU hungry for small disk savings
    to matter.
  * Autodetect -fno-fat-lto-objects.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 02 May 2013 14:03:18 +0200

crawl (2:0.11.2-2) experimental; urgency=low

  * Don't use -fno-fat-lto-objects, the buildds do not support that yet.

 -- Guus Sliepen <guus@debian.org>  Wed, 20 Feb 2013 14:27:41 +0100

crawl (2:0.11.2-1) experimental; urgency=low

  * New upstream release.

 -- Guus Sliepen <guus@debian.org>  Wed, 20 Feb 2013 13:04:51 +0100

crawl (2:0.11.1-2) experimental; urgency=low

  * Enable link time optimization (LTO).

 -- Guus Sliepen <guus@debian.org>  Wed, 05 Dec 2012 14:03:18 +0100

=== debian/control ===
Source: crawl
Section: games
Priority: optional
Maintainer: Guus Sliepen <guus@debian.org>
Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
DM-Upload-Allowed: yes
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
	libfreetype6-dev, advancecomp, libpng-dev
Homepage: http://crawl.develz.org/

Package: crawl-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: crawl | crawl-tiles
Description: Dungeon Crawl, a text-based roguelike game (data files)
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 These are the data and support files.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
Description: Dungeon Crawl, a text-based roguelike game
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the console version, for tiles, use crawl-tiles instead.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl-tiles-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
Conflicts: crawl-tiles (<< 2:0.11.1-1)
Replaces: crawl-tiles (<< 2:0.11.1-1)
Recommends: crawl-tiles
Description: Dungeon Crawl, a text-based roguelike game (tile data files)
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 These are the tile graphics.
 .
 This is the Stone Soup version of Dungeon Crawl.Package: crawl-tiles

Package: crawl-tiles
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), crawl-tiles-data (= ${source:Version}), ttf-dejavu
Description: Dungeon Crawl, a roguelike game, tiles version
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the graphical (tiles) version.
 .
 This is the Stone Soup version of Dungeon Crawl.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

ifneq (,$(shell gcc --version|grep 'gcc (.*) 4\.4\.'))
  ifeq ($(DEB_HOST_ARCH),powerpc)
	# g++-4.4 has an ICE there.
	DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) noopt
  endif
endif
CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) \
             $(shell dpkg-buildflags --get LDFLAGS) \
             $(shell dpkg-buildflags --get CPPFLAGS)
ifeq ($(shell g++ -x c++ /dev/null -flto=jobserver -fwhole-program 2>&1 | grep 'unrecognized command line option'),)
  CFOPTIMIZE += -flto=jobserver -fwhole-program
endif
ifeq ($(shell g++ -x c++ /dev/null -fno-fat-lto-objects 2>&1 | grep 'unrecognized command line option'),)
  CFOPTIMIZE += -fno-fat-lto-objects
endif

ifeq (,$(filter terse%,$(DEB_BUILD_OPTIONS))$(filter quiet%,$(DEB_BUILD_OPTIONS)))
        VERBOSE=V=y
endif

tree-stamp:
	dh_testdir
	mkdir build-console
	cp -ldpR docs settings source CREDITS.txt build-console/
	mkdir build-tiles
	cp -ldpR docs settings source CREDITS.txt build-tiles/
	touch tree-stamp

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CROSS=CROSSHOST=$(DEB_HOST_GNU_TYPE)
endif

# The makefile is unorthodox, requiring all options to be specified on every invocation.
ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS) $(VERBOSE)
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf

build-arch build-indep: build-stamp
build-stamp: tree-stamp
	dh_testdir

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE)
	cd build-tiles/source && $(MAKE) $(ARGS_TILES)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp tree-stamp
	rm -rf build-console build-tiles

	git clean -dfX || true

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE) install DESTDIR=../../debian/crawl-common
	#cd debian/crawl-common/usr/share && mkdir -p doc/crawl-common && \
	#	mv crawl/docs/* doc/crawl-common && \
	#	mv doc/crawl-common/crawl_manual.txt crawl/docs
	rm -rf debian/crawl-common/usr/share/crawl/docs/license
	mkdir -p debian/crawl/usr/
	mv debian/crawl-common/usr/games debian/crawl/usr/games
	cd build-tiles/source && $(MAKE) $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
	rm -rf debian/crawl-tiles/var
	cd debian/crawl-tiles/usr/share/crawl/ && rm -rf docs settings
	mkdir -p debian/crawl-tiles-data/usr/share/crawl/dat
	mv debian/crawl-tiles/usr/share/crawl/dat/tiles debian/crawl-tiles-data/usr/share/crawl/dat/
	rm -rf debian/crawl-tiles/usr/share/crawl/dat
	
	mkdir -p debian/crawl/usr/share/man/man6
	cp docs/crawl.6 debian/crawl/usr/share/man/man6/
	mkdir -p debian/crawl-tiles/usr/share/man/man6
	cp docs/crawl.6 debian/crawl-tiles/usr/share/man/man6/crawl-tiles.6
	mkdir -p debian/crawl-common/usr/share/doc/crawl-common/examples
	cp settings/init.txt debian/crawl-common/usr/share/doc/crawl-common/examples/crawlrc
	for i in docs/*.txt; do \
		ln -sf /usr/share/crawl/$$i debian/crawl-common/usr/share/doc/crawl-common/; \
	done

	mkdir -p debian/crawl/usr/share/doc
	ln -sf crawl-common debian/crawl/usr/share/doc/crawl
	mkdir -p debian/crawl-tiles/usr/share/doc
	ln -sf crawl-common debian/crawl-tiles/usr/share/doc/crawl-tiles
	mkdir -p debian/crawl-tiles-data/usr/share/doc
	ln -sf crawl-common debian/crawl-tiles-data/usr/share/doc/crawl-tiles-data
	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications
	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps
	dh_link -pcrawl-tiles usr/share/crawl/dat/tiles/stone_soup_icon-32x32.png \
		usr/share/icons/hicolor/32x32/apps/crawl.png
	mkdir -p debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps
	cp -p source/util/dcss.svg \
		debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps/crawl.svg

# Build architecture-independent files here.
binary-indep: install
	dh_testdir
	dh_testroot
	dh_installdocs -pcrawl-common -Xcrawl_manual.txt -Xaptitudes.txt -Xquickstart.txt -Xmacros_guide.txt -Xoptions_guide.txt -Xtiles_help.txt
	dh_installchangelogs -pcrawl-common docs/changelog.txt
	dh_link -i
	dh_compress -i -Xaptitudes.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installmenu -a
	dh_link -a
	dh_compress -a -Xaptitudes.txt
	dh_strip -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

build: build-indep build-arch
binary: binary-indep binary-arch
.PHONY: build-indep build-arch build clean binary-indep binary-arch binary install

## crawl 0.12.2

=== source/Makefile ===
--- 
+++ 
@@ -100,24 +100,6 @@
 # CFOTHERS(_L) - Anything else
 #
 
-
-ifdef USE_ICC
-
-# If you have a Core 2 processor, this _really_ makes things fly:
-#CFOPTIMIZE := -O2 -parallel -xT
-
-# Optionally enable the 'ipo' feature, to facilitate inlining
-# across object file bounds.
-#CFOPTIMIZE_L := -ipo
-
-# Some very good optimization flags.
-CFOPTIMIZE := -O2 -parallel
-
-else
-
-CFOPTIMIZE := -O2
-
-endif # USE_ICC
 
 CFOTHERS := -pipe $(EXTERNAL_FLAGS)
 CFWARN := -Wall -Wformat-security
@@ -429,3 +411,22 @@
 endif
 
 ifndef SDK_VER
+ifeq ($(MARCH),ppc)
+SDK_VER := 10.4
+endif
+ifeq ($(MARCH),i386)
+SDK_VER := 10.4
+endif
+ifeq ($(MARCH),x86_64)
+ifdef TILES
+SDK_VER := 10.6
+else
+SDK_VER := 10.5
+endif
+endif
+endif
+
+# Mac OS X 10.4 adds a 'u' on the end of the SDK name. Everything
+# else is much easier to predict the name of.
+ifeq ($(SDK_VER),10.4)
+GCC_VER := 4.0

=== debian/changelog ===
crawl (2:0.12.2-1) unstable; urgency=low

  * New upstream bugfix release
  * Give up and drop LTO on rare architectures, ie, anything but *arm*,
    *amd64*, *x32*, *i386*. There's apparently always an ICE on at least
    one arch somewhere among gcc-4.6/4.7/4.8/clang on Debian or Ubuntu.
  * Drop obsolete DM-Upload-Allowed.
  * Properly query DEB_HOST_ARCH on new dpkg-dev.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 08 Jun 2013 04:34:41 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Priority: optional
 Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
-DM-Upload-Allowed: yes
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
 	libfreetype6-dev, advancecomp, libpng-dev

=== debian/rules ===
--- 
+++ 
@@ -5,20 +5,38 @@
 	MAKEFLAGS += -j$(NUMJOBS)
 endif
 
+DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
 ifneq (,$(shell gcc --version|grep 'gcc (.*) 4\.4\.'))
   ifeq ($(DEB_HOST_ARCH),powerpc)
 	# g++-4.4 has an ICE there.
 	DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) noopt
   endif
 endif
+
+ifneq (,$(findstring arm,$(DEB_HOST_ARCH)))
+  LTO=y
+endif
+ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
+  LTO=y
+endif
+ifneq (,$(findstring x32,$(DEB_HOST_ARCH)))
+  LTO=y
+endif
+ifneq (,$(findstring i386,$(DEB_HOST_ARCH)))
+  LTO=y
+endif
+
 CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) \
              $(shell dpkg-buildflags --get LDFLAGS) \
              $(shell dpkg-buildflags --get CPPFLAGS)
-ifeq ($(shell g++ -x c++ /dev/null -flto=jobserver -fwhole-program 2>&1 | grep 'unrecognized command line option'),)
-  CFOPTIMIZE += -flto=jobserver -fwhole-program
-endif
-ifeq ($(shell g++ -x c++ /dev/null -fno-fat-lto-objects 2>&1 | grep 'unrecognized command line option'),)
-  CFOPTIMIZE += -fno-fat-lto-objects
+ifneq ($(LTO),)
+  ifeq ($(shell g++ -x c++ /dev/null -flto=jobserver -fwhole-program 2>&1 | grep 'unrecognized command line option'),)
+    CFOPTIMIZE += -flto=jobserver -fwhole-program
+  endif
+  ifeq ($(shell g++ -x c++ /dev/null -fno-fat-lto-objects 2>&1 | grep 'unrecognized command line option'),)
+    CFOPTIMIZE += -fno-fat-lto-objects
+  endif
 endif
 
 ifeq (,$(filter terse%,$(DEB_BUILD_OPTIONS))$(filter quiet%,$(DEB_BUILD_OPTIONS)))

## crawl 0.12.3

=== debian/changelog ===
crawl (2:0.12.3-1) unstable; urgency=low

  * New upstream release.

 -- Guus Sliepen <guus@debian.org>  Mon, 30 Sep 2013 00:07:28 +0200

## crawl 0.13.0

=== source/Makefile ===
--- 
+++ 
@@ -222,9 +222,6 @@
 	endif
 	COPY_FONTS = yes
 endif
-ifdef USE_LUAJIT
-	BUILD_LUA := YesPlease
-endif
 ifdef USE_ICC
 	NO_RDYNAMIC := YesPlease
 endif
@@ -430,3 +427,5 @@
 # else is much easier to predict the name of.
 ifeq ($(SDK_VER),10.4)
 GCC_VER := 4.0
+SDKROOT := $(DEVELOPER_PATH)/SDKs/MacOSX$(SDK_VER)u.sdk
+else

=== debian/changelog ===
crawl (2:0.13.0-2) unstable; urgency=low

  * Fix the tilesheets being out of sync between builds (including arch:all
    parts vs arch:any). Closes: #729938
  * Disable LTO on arm{el,hf}, due to binutils bug #712189.
  * Depend on fonts-dejavu-core rather than ttf-dejavu, keeping the latter as
    an alternative because of backports.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 19 Nov 2013 04:02:18 +0100

crawl (2:0.13.0-1) unstable; urgency=low

  * New upstream release.
  * Removed source/contrib from upstream tarball.

 -- Guus Sliepen <guus@debian.org>  Mon, 18 Nov 2013 14:42:24 +0100

## crawl 0.13.1

=== source/Makefile ===
--- 
+++ 
@@ -201,8 +201,8 @@
 		BUILD_SDLIMAGE = YesPlease
 		BUILD_LIBPNG = YesPlease
 	endif
-	ifeq ($(shell gcc -v -static-libstdc++ 2>&1 | grep 'unrecognized option'),)
-		EXTRA_LIBS += -static-libgcc -static-libstdc++
+	ifeq ($(shell gcc -v -static -static-libstdc++ 2>&1 | grep 'unrecognized option'),)
+		EXTRA_LIBS += -static -static-libgcc -static-libstdc++
 	endif
 	COPY_FONTS = yes
 endif
@@ -427,5 +427,3 @@
 # else is much easier to predict the name of.
 ifeq ($(SDK_VER),10.4)
 GCC_VER := 4.0
-SDKROOT := $(DEVELOPER_PATH)/SDKs/MacOSX$(SDK_VER)u.sdk
-else

=== source/rltiles/Makefile ===
uname_S := $(shell uname -s)

ifneq (,$(findstring MINGW,$(uname_S)))
LDFLAGS += -lmingw32
endif

# Note: since generation of tiles is done on the host, we don't care about
# cross-compilation here.
#
# Also, cross-compilation with no system libraries for host rather than target
# is not supported.  If host=target, contribs are enough.

CFLAGS := -O2 -g -Wall -Wextra -Wno-parentheses -Wno-unused-parameter

ifdef ANDROID
  CXXFLAGS :=
  LDFLAGS :=
  LIBS :=
endif

ifdef TILES
  ifndef CONTRIB_SDL
    SDL_CFLAGS := $(shell sdl-config --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include/SDL")
    SDL_LDFLAGS := $(shell sdl-config --libs 2> /dev/null && echo "-lSDL_image" || echo "../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a")
  else
    SDL_CFLAGS := -I../contrib/install/$(ARCH)/include/SDL
    SDL_LDFLAGS := ../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a
  endif

  ifndef NO_PKGCONFIG
    PNG_INCLUDE := $(shell pkg-config libpng --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include")
    PNG_LIB := $(shell pkg-config libpng --libs 2> /dev/null || echo "../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a")
  else
    PNG_INCLUDE := -I../contrib/install/$(ARCH)/include
    PNG_LIB := ../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a
  endif

  CFLAGS += $(SDL_CFLAGS) $(PNG_INCLUDE)
  LDFLAGS += $(SDL_LDFLAGS) $(PNG_LIB)

  CFLAGS += -DUSE_TILE
endif

ifdef DEBUG
CFLAGS += -O0 -DDEBUG -ggdb
endif

ifneq (,$(findstring MINGW,$(uname_S)))
LDFLAGS += -lgdi32 -lwinmm
endif
ifeq ($(uname_S),Darwin)
LDFLAGS += -framework AppKit -framework AudioUnit -framework Carbon -framework IOKit -framework OpenGL
endif
ifeq ($(uname_S),Linux)
LDFLAGS += -ldl -lpthread
endif

# Attempt to use a full compiler name, to make
# distcc builds work nicely.
LMACH := $(shell gcc -dumpmachine)-
ifeq ($(LMACH),-)
LMACH :=
endif
ifeq ($(shell which $(LMACH)gcc > /dev/null 2> /dev/null && echo "Yes"),)
LMACH :=
endif
HOSTCXX ?= $(LMACH)g++

DELETE = rm -f

TOOLDIR := tool
TILEGEN := $(TOOLDIR)/tilegen.elf

INPUTS := main dngn floor wall feat player gui icons
INPUTFILES := $(INPUTS:%=dc-%.txt)
HEADERS := $(INPUTS:%=tiledef-%.h)
HTML := $(INPUTS:%=tile-%.html)
SOURCE := $(INPUTS:%=tiledef-%.cc)
IMAGES := $(INPUTS:%=%.png)
JAVASCRIPT := $(INPUTS:%=tileinfo-%.js)

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_HOSTCXX  = @echo '   ' HOSTCXX $@;
        QUIET_GEN      = @echo '   ' GEN $@;
        QUIET_HOSTLINK = @echo '   ' HOSTLINK $@;
        export V
endif
endif

BASE_OBJECTS := tile_colour.o tile.o tile_page.o tile_list_processor.o main.o

OBJECTS := $(BASE_OBJECTS:%=$(TOOLDIR)/%)

all: $(TILEGEN) $(HEADERS) $(SOURCE) $(JAVASCRIPT)
ifdef TILES
all: $(IMAGES)
endif

%.png: dc-%.txt $(TILEGEN)
	$(QUIET_GEN)$(TILEGEN) -i $<

ifdef TILES
# Keep coordinates fresh
tiledef-%.h tiledef-%.cc tileinfo-%.js: dc-%.txt $(TILEGEN) %.png
else
tiledef-%.h tiledef-%.cc tileinfo-%.js: dc-%.txt $(TILEGEN)
endif
	$(QUIET_GEN)$(TILEGEN) -c $<

# CFLAGS difference check
TRACK_CFLAGS = $(subst ','\'',$(HOSTCXX) $(CFLAGS))           # (stray ' for highlights)

.cflags: .force-cflags
	@FLAGS='$(TRACK_CFLAGS)'; \
    if test x"$$FLAGS" != x"`cat .cflags 2>/dev/null`" ; then \
        echo "    * rebuilding tilegen: new build flags or prefix"; \
        echo "$$FLAGS" > .cflags; \
    fi

.PHONY: .force-cflags

##########################################################################
# Dependencies 

gui.png tiledef-gui.h tileinfo-gui.js: dc-spells.txt dc-skills.txt dc-commands.txt dc-abilities.txt dc-invocations.txt dc-zotdef.txt
main.png tiledef-main.h tileinfo-main.js: dc-item.txt dc-unrand.txt dc-corpse.txt dc-misc.txt
player.png tiledef-player.h tileinfo-player.js: dc-mon.txt dc-tentacles.txt dc-zombie.txt dc-demon.txt

DEPS := $(OBJECTS:%.o=%.d) $(INPUTS:%=%.d)

-include $(DEPS)

clean:
	$(DELETE) $(HEADERS) $(OBJECTS) $(TILEGEN) $(SOURCE) $(IMAGES) $(HTML) \
		$(DEPS) $(JAVASCRIPT) .cflags

distclean: clean

%.o: %.cc .cflags
	$(QUIET_HOSTCXX)$(HOSTCXX) $(CFLAGS) -MMD -c $< -o $@

$(TILEGEN): $(OBJECTS)
	$(QUIET_HOSTLINK)$(HOSTCXX) $(OBJECTS) -o $@ $(LDFLAGS)

.PHONY: all clean distclean

=== source/util/Makefile ===
YACC := bison -y
LEX  := flex
RM   ?= rm -f

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_YACC     = @echo '   ' YACC $@;
        QUIET_LEX      = @echo '   ' LEX $@;
        export V
endif
endif

all: levcomp.tab.cc levcomp.lex.cc

clean:
	$(RM) levcomp.tab.cc levcomp.tab.h levcomp.lex.cc *.o

%.tab.cc: %.tab.c
	@mv $< $@

%.lex.cc: %.lpp
	$(QUIET_LEX)$(LEX) -o$@ $<

%.tab.c: %.ypp
	$(QUIET_YACC)$(YACC) -d -b $* $<

=== debian/changelog ===
crawl (2:0.13.1-1) unstable; urgency=low

  * New upstream release

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 28 Nov 2013 12:05:56 +0100

=== debian/control ===
--- 
+++ 
@@ -54,7 +54,7 @@
 
 Package: crawl-tiles
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), crawl-tiles-data (= ${source:Version}), ttf-dejavu
+Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), crawl-tiles-data (= ${source:Version}), fonts-dejavu-core | ttf-dejavu
 Description: Dungeon Crawl, a roguelike game, tiles version
  Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
  Moria. Your objective is to travel deep into a subterranean cave complex and

=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,6 @@
   endif
 endif
 
-ifneq (,$(findstring arm,$(DEB_HOST_ARCH)))
-  LTO=y
-endif
 ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
   LTO=y
 endif

## crawl 0.14.1

=== source/Makefile ===
--- 
+++ 
@@ -373,7 +373,7 @@
 endif
 
 
-INCLUDES_L += -Icontrib/install/$(ARCH)/include
+INCLUDES_L += -isystem contrib/install/$(ARCH)/include
 LIBS += -Lcontrib/install/$(ARCH)/lib
 
 INCLUDES_L += -Iutil -I.

=== source/util/Makefile ===
--- 
+++ 
@@ -13,13 +13,10 @@
 all: levcomp.tab.cc levcomp.lex.cc
 
 clean:
-	$(RM) levcomp.tab.cc levcomp.tab.h levcomp.lex.cc *.o
-
-%.tab.cc: %.tab.c
-	@mv $< $@
+	$(RM) levcomp.tab.cc levcomp.tab.h levcomp.lex.cc *.o *.d
 
 %.lex.cc: %.lpp
 	$(QUIET_LEX)$(LEX) -o$@ $<
 
-%.tab.c: %.ypp
-	$(QUIET_YACC)$(YACC) -d -b $* $<
+%.tab.cc: %.ypp
+	$(QUIET_YACC)$(YACC) --defines=$*.tab.h -b $* -o $@ $<

=== debian/changelog ===
crawl (2:0.14.1-2) unstable; urgency=medium

  * Look for fonts in /usr/share/fonts/truetype/dejavu/ instead of
    ttf-dejavu/, and Depend strictly on fonts-dejavu-core. Closes: #753837

 -- Guus Sliepen <guus@debian.org>  Wed, 23 Jul 2014 17:59:47 +0200

crawl (2:0.14.1-1) unstable; urgency=medium

  * New upstream release. Closes: #747156
  * Remove source/contrib and source/webserver from the original tarball.
  * Add a .desktop file for the non-tiles version, and provide an icon for
    the menu files. Closes: #737850
  * Bump Standards-Version.

 -- Guus Sliepen <guus@debian.org>  Thu, 08 May 2014 16:18:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
 	libfreetype6-dev, advancecomp, libpng-dev
@@ -54,7 +54,7 @@
 
 Package: crawl-tiles
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), crawl-tiles-data (= ${source:Version}), fonts-dejavu-core | ttf-dejavu
+Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), crawl-tiles-data (= ${source:Version}), fonts-dejavu-core
 Description: Dungeon Crawl, a roguelike game, tiles version
  Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
  Moria. Your objective is to travel deep into a subterranean cave complex and

=== debian/rules ===
--- 
+++ 
@@ -57,8 +57,8 @@
 # The makefile is unorthodox, requiring all options to be specified on every invocation.
 ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS) $(VERBOSE)
 ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
-	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
-	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
+	PROPORTIONAL_FONT=/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf \
+	MONOSPACED_FONT=/usr/share/fonts/truetype/dejavu/DejaVuSansMono.ttf
 
 build-arch build-indep: build-stamp
 build-stamp: tree-stamp
@@ -116,8 +116,10 @@
 	ln -sf crawl-common debian/crawl-tiles/usr/share/doc/crawl-tiles
 	mkdir -p debian/crawl-tiles-data/usr/share/doc
 	ln -sf crawl-common debian/crawl-tiles-data/usr/share/doc/crawl-tiles-data
-	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications
-	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps
+	dh_install -pcrawl debian/crawl.desktop usr/share/applications/
+	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications/
+	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps/
+	dh_install -pcrawl-common debian/crawl.xpm usr/share/pixmaps/
 	dh_link -pcrawl-tiles usr/share/crawl/dat/tiles/stone_soup_icon-32x32.png \
 		usr/share/icons/hicolor/32x32/apps/crawl.png
 	mkdir -p debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps

## crawl 0.15.1

=== source/Makefile ===
--- 
+++ 
@@ -192,7 +192,7 @@
 	NEED_LIBW32C = YesPlease
 	BUILD_PCRE = YesPlease
 	BUILD_ZLIB = YesPlease
-	DEFINES_L += -DWINMM_PLAY_SOUNDS
+	DEFINES_L += -DWINMM_PLAY_SOUNDS -D__USE_MINGW_ANSI_STDIO
 	EXTRA_LIBS += -lwinmm
 	ifdef TILES
 		EXTRA_LIBS += -lmingw32 -lgdi32 -lwinmm contrib/install/$(ARCH)/lib/libSDLmain.a -mwindows
@@ -200,11 +200,11 @@
 		BUILD_SDL = YesPlease
 		BUILD_SDLIMAGE = YesPlease
 		BUILD_LIBPNG = YesPlease
+		COPY_FONTS = yes
 	endif
 	ifeq ($(shell gcc -v -static -static-libstdc++ 2>&1 | grep 'unrecognized option'),)
 		EXTRA_LIBS += -static -static-libgcc -static-libstdc++
 	endif
-	COPY_FONTS = yes
 endif
 ifeq ($(uname_S),Darwin)
 	STRIP := strip -x
@@ -219,8 +219,8 @@
 		BUILD_SDL = YesPlease
 		BUILD_SDLIMAGE = YesPlease
 		BUILD_LIBPNG = YesPlease
+		COPY_FONTS = yes
 	endif
-	COPY_FONTS = yes
 endif
 ifdef USE_ICC
 	NO_RDYNAMIC := YesPlease
@@ -373,9 +373,6 @@
 endif
 
 
-INCLUDES_L += -isystem contrib/install/$(ARCH)/include
-LIBS += -Lcontrib/install/$(ARCH)/lib
-
 INCLUDES_L += -Iutil -I.
 
 ifdef APPLE_GCC
@@ -427,3 +424,5 @@
 # else is much easier to predict the name of.
 ifeq ($(SDK_VER),10.4)
 GCC_VER := 4.0
+SDKROOT := $(DEVELOPER_PATH)/SDKs/MacOSX$(SDK_VER)u.sdk
+else

=== debian/changelog ===
crawl (2:0.15.1-1) unstable; urgency=medium

  * New upstream release. Closes: #762299
  * Add --ignore-missing-info to shlibdeps, otherwise it fails because there
    is no dependency information for libGL.so.1.
  * Bump Standards-Version.

 -- Guus Sliepen <guus@debian.org>  Mon, 06 Oct 2014 13:28:55 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
 	libfreetype6-dev, advancecomp, libpng-dev

=== debian/rules ===
--- 
+++ 
@@ -150,7 +150,7 @@
 	dh_strip -a
 	dh_fixperms -a
 	dh_installdeb -a
-	dh_shlibdeps -a
+	dh_shlibdeps -a -- --ignore-missing-info
 	dh_gencontrol -a
 	dh_md5sums -a
 	dh_builddeb -a

## crawl 0.16.1

=== source/Makefile ===
--- 
+++ 
@@ -17,6 +17,8 @@
 #       installing even if you just built it.
 # Typical parameters:
 #    TILES         -- set to anything to enable tiles build
+#
+#    SOUND         -- set to anything to enable sound
 #
 #    CROSSHOST     -- target system, eg, i386-pc-msdosdjgpp or i586-mingw32msvc
 #
@@ -64,10 +66,10 @@
 #
 # Requirements:
 #    For tile builds, you need pkg-config.
-#    You also need libpng, sdl, sdl-image and libfreetype -- if you got your
-#    source from git, you can 'git submodule update' to fetch them; you can also
-#    ask for a package with convenience libraries instead -- we'll try to provide
-#    them somewhere in the near future.
+#    You also need libpng, sdl2, sdl2-image, sdl2-mixer and libfreetype -- if
+#    you got your source from git, you can 'git submodule update' to fetch
+#    them; you can also ask for a package with convenience libraries instead --
+#    we'll try to provide them somewhere in the near future.
 
 GAME = crawl
 
@@ -79,7 +81,7 @@
 
 .PHONY: all test install clean clean-contrib clean-rltiles clean-android \
         distclean debug debug-lite profile package-source source \
-        build-windows package-windows rest docs greet api android
+        build-windows package-windows rest docs greet api android FORCE
 
 include Makefile.obj
 
@@ -102,8 +104,8 @@
 
 
 CFOTHERS := -pipe $(EXTERNAL_FLAGS)
-CFWARN := -Wall -Wformat-security
-CFWARN_L := -Wundef
+CFWARN := 
+CFWARN_L := -Wall -Wformat-security -Wundef
 
 DEFINES := $(EXTERNAL_DEFINES)
 
@@ -192,13 +194,14 @@
 	NEED_LIBW32C = YesPlease
 	BUILD_PCRE = YesPlease
 	BUILD_ZLIB = YesPlease
+	SOUND = YesPlease
 	DEFINES_L += -DWINMM_PLAY_SOUNDS -D__USE_MINGW_ANSI_STDIO
 	EXTRA_LIBS += -lwinmm
 	ifdef TILES
-		EXTRA_LIBS += -lmingw32 -lgdi32 -lwinmm contrib/install/$(ARCH)/lib/libSDLmain.a -mwindows
+		EXTRA_LIBS += -lmingw32 -lgdi32 -lwinmm -limm32 -lole32 -loleaut32 -lversion contrib/install/$(ARCH)/lib/libSDL2main.a -mwindows
 		BUILD_FREETYPE = YesPlease
-		BUILD_SDL = YesPlease
-		BUILD_SDLIMAGE = YesPlease
+		BUILD_SDL2 = YesPlease
+		BUILD_SDL2IMAGE = YesPlease
 		BUILD_LIBPNG = YesPlease
 		COPY_FONTS = yes
 	endif
@@ -214,10 +217,15 @@
 	BUILD_SQLITE = YesPlease
 	BUILD_ZLIB = YesPlease
 	ifdef TILES
-		EXTRA_LIBS += -framework AppKit -framework AudioUnit -framework Carbon -framework IOKit -framework OpenGL contrib/install/$(ARCH)/lib/libSDLmain.a
+		EXTRA_LIBS += -framework AppKit -framework AudioUnit -framework CoreAudio -framework ForceFeedback -framework Carbon -framework IOKit -framework OpenGL contrib/install/$(ARCH)/lib/libSDL2main.a
 		BUILD_FREETYPE = YesPlease
-		BUILD_SDL = YesPlease
-		BUILD_SDLIMAGE = YesPlease
+		BUILD_SDL2 = YesPlease
+		BUILD_SDL2IMAGE = YesPlease
+		ifdef SOUND
+			ifndef WIN32 
+				BUILD_SDL2MIXER = YesPlease
+			endif
+		endif
 		BUILD_LIBPNG = YesPlease
 		COPY_FONTS = yes
 	endif
@@ -234,8 +242,13 @@
 ifdef BUILD_ALL
 	BUILD_FREETYPE = YesPlease
 	BUILD_PCRE = YesPlease
-	BUILD_SDL = YesPlease
-	BUILD_SDLIMAGE = YesPlease
+	BUILD_SDL2 = YesPlease
+	BUILD_SDL2IMAGE = YesPlease
+	ifdef SOUND
+		ifndef WIN32 
+			BUILD_SDL2MIXER = YesPlease
+		endif
+	endif
 	BUILD_SQLITE = YesPlease
 	BUILD_LUA = YesPlease
 	BUILD_LIBPNG = YesPlease
@@ -246,9 +259,10 @@
 all: greet check-fonts $(GAME) docs webserver
 
 LIBPCRE := contrib/install/$(ARCH)/lib/libpcre.a
-LIBSDL := contrib/install/$(ARCH)/lib/libSDL.a
+LIBSDL2 := contrib/install/$(ARCH)/lib/libSDL2.a
 LIBPNG := contrib/install/$(ARCH)/lib/libpng.a
-LIBSDLIMAGE := contrib/install/$(ARCH)/lib/libSDL_image.a
+LIBSDL2IMAGE := contrib/install/$(ARCH)/lib/libSDL2_image.a
+LIBSDL2MIXER := contrib/install/$(ARCH)/lib/libSDL2_mixer.a
 LIBFREETYPE := contrib/install/$(ARCH)/lib/libfreetype.a
 LIBSQLITE := contrib/install/$(ARCH)/lib/libsqlite3.a
 ifdef USE_LUAJIT
@@ -384,45 +398,15 @@
 
 # The SDK locations were moved in 10.8; this snippet tries to find them
 # there first, then reverts to the original location.
-ifeq ($(shell test -e /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer || echo NOPE),)
-DEVELOPER_PATH := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer
-else
-DEVELOPER_PATH := /Developer
-endif
-
-# Find the oldest SDK available, in attempt to make this build as
-# backward-compatible as we possibly can.
-SDK_VER := $(shell ls $(DEVELOPER_PATH)/SDKs | sort -n | head -1 | perl -pe 's/^MacOSX//g;s/.sdk$$//g')
-
-ifeq ($(SDK_VER),10.4u)
-SDK_VER := 10.4
-endif
-
-ifndef SDK_VER
-$(error You do not seem to have any Mac OS X SDKs installed! This build is doomed to fail)
-endif
-
-endif
-
-ifndef SDK_VER
-ifeq ($(MARCH),ppc)
-SDK_VER := 10.4
-endif
-ifeq ($(MARCH),i386)
-SDK_VER := 10.4
-endif
-ifeq ($(MARCH),x86_64)
-ifdef TILES
-SDK_VER := 10.6
-else
-SDK_VER := 10.5
-endif
-endif
-endif
-
-# Mac OS X 10.4 adds a 'u' on the end of the SDK name. Everything
-# else is much easier to predict the name of.
-ifeq ($(SDK_VER),10.4)
-GCC_VER := 4.0
-SDKROOT := $(DEVELOPER_PATH)/SDKs/MacOSX$(SDK_VER)u.sdk
-else
+XCODE_SDK_SUFFIX := Platforms/MacOSX.platform/Developer
+# Try to use xcode-select -p to find the current user-configured Xcode.app.
+XCODE_SELECT_PATH := $(shell xcode-select -p 2>/dev/null | sed 's/\/$$//')
+ifeq ($(shell test -e "$(XCODE_SELECT_PATH)/$(XCODE_SDK_SUFFIX)" || echo NOPE),)
+DEVELOPER_PATH := $(XCODE_SELECT_PATH)/$(XCODE_SDK_SUFFIX)
+else
+# Otherwise, try /Applications/Xcode.app.
+XCODE_DEFAULT_PATH := /Applications/Xcode.app/Contents/Developer
+ifeq ($(shell test -e "$(XCODE_DEFAULT_PATH)/$(XCODE_SDK_SUFFIX)" || echo NOPE),)
+DEVELOPER_PATH := $(XCODE_DEFAULT_PATH)/$(XCODE_SDK_SUFFIX)
+else
+# If all else fails, maybe it's in /Developer.

=== source/rltiles/Makefile ===
--- 
+++ 
@@ -19,14 +19,6 @@
 endif
 
 ifdef TILES
-  ifndef CONTRIB_SDL
-    SDL_CFLAGS := $(shell sdl-config --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include/SDL")
-    SDL_LDFLAGS := $(shell sdl-config --libs 2> /dev/null && echo "-lSDL_image" || echo "../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a")
-  else
-    SDL_CFLAGS := -I../contrib/install/$(ARCH)/include/SDL
-    SDL_LDFLAGS := ../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a
-  endif
-
   ifndef NO_PKGCONFIG
     PNG_INCLUDE := $(shell pkg-config libpng --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include")
     PNG_LIB := $(shell pkg-config libpng --libs 2> /dev/null || echo "../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a")
@@ -35,8 +27,8 @@
     PNG_LIB := ../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a
   endif
 
-  CFLAGS += $(SDL_CFLAGS) $(PNG_INCLUDE)
-  LDFLAGS += $(SDL_LDFLAGS) $(PNG_LIB)
+  CFLAGS += $(PNG_INCLUDE)
+  LDFLAGS += $(PNG_LIB)
 
   CFLAGS += -DUSE_TILE
 endif
@@ -46,10 +38,10 @@
 endif
 
 ifneq (,$(findstring MINGW,$(uname_S)))
-LDFLAGS += -lgdi32 -lwinmm
+LDFLAGS += -lgdi32 -lwinmm -lole32 -loleaut32 -limm32 -lshell32 -lversion -luuid 
 endif
 ifeq ($(uname_S),Darwin)
-LDFLAGS += -framework AppKit -framework AudioUnit -framework Carbon -framework IOKit -framework OpenGL
+LDFLAGS += -framework AppKit -framework AudioUnit -framework CoreAudio -framework ForceFeedback -framework Carbon -framework IOKit -framework OpenGL
 endif
 ifeq ($(uname_S),Linux)
 LDFLAGS += -ldl -lpthread

=== debian/changelog ===
crawl (2:0.16.1-1) unstable; urgency=medium

  * New upstream release.
  * Switch to SDL2.
  * Disable LTO completely due to ICE.

 -- Guus Sliepen <guus@debian.org>  Mon, 20 Apr 2015 14:47:37 +0200

=== debian/rules ===
--- 
+++ 
@@ -14,15 +14,16 @@
   endif
 endif
 
-ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
-  LTO=y
-endif
-ifneq (,$(findstring x32,$(DEB_HOST_ARCH)))
-  LTO=y
-endif
-ifneq (,$(findstring i386,$(DEB_HOST_ARCH)))
-  LTO=y
-endif
+#LTO is currently broken.
+#ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
+#  LTO=y
+#endif
+#ifneq (,$(findstring x32,$(DEB_HOST_ARCH)))
+#  LTO=y
+#endif
+#ifneq (,$(findstring i386,$(DEB_HOST_ARCH)))
+#  LTO=y
+#endif
 
 CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) \
              $(shell dpkg-buildflags --get LDFLAGS) \

## crawl 0.16.2

=== debian/changelog ===
crawl (2:0.16.2-1) unstable; urgency=medium

  * New upstream release.
  * Update debian/watch file.

 -- Guus Sliepen <guus@debian.org>  Sun, 20 Sep 2015 15:13:43 +0200
